// 任务描述：
// 定义两个函数，一个名为stringZip(iStr)，一个名为stringUnzip()；
// stringZip(iStr)，输入为a-z,A-Z的字符串，且字符串不为空，如aaabccccccddeee，输出压缩后的字符串，如3a1b6c2d3e
// stringUnzip(iStr)，逻辑与stringZip(iStr)相反

var cl = require('console');
var _ = require('lodash');
var reg = new RegExp('^[a-zA-Z]+$');

function stringZip(iStr){
    if((typeof iStr == 'string') && iStr != '' && reg.test(iStr)){
        var count = 1; //计数
        var str = '';
        var index = 1; //被比较字符的索引

        var nextChar = iStr[0];

        if(iStr.length == index){
            return count+iStr;
        };

        while(index < iStr.length){
            if(iStr[index] != nextChar){
                str += (count + nextChar);
                count = 1;
                nextChar = iStr[index];
            }else{
                count += 1;
            };
            index += 1;
        };
        
        str += (count + nextChar);
        
        return str;
    }else{
        cl.log('不是字符串 或 字符串为空 或 不是纯英文字母');
    };
};

function stringUnzip(iStr){
    var str1 = '';
    for(var i=0; i<iStr.length; i+=2){
        str2 = '';
        var n = _.toNumber(iStr[i]);
        for(var j=0; j<n; j++){
            str1 += iStr[i+1];
        };
        str2 += str1;
    };
    return str1;
};

a = 'aaanaaanbbnnnbbbbbbbbbbsssssss';
cl.log(stringZip(a));

b = '3a5b4c7d9f';
cl.log(stringUnzip(b));